;;; buffer-fep.el --- Control Human68K Nihongo front processor.

;; Copyright (C) 1995 MINOURA Makoto

;; This file is part of GNU Emacs for Human68K.

;; GNU Emacs is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; GNU Emacs is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;;; Commentary

;; obt@ɓ{tgvZbT̏Ԃ𐧌䂵܂B
;; M-x load-library[RET] buffer-fep[RET] Ɠ͂邩A
;; .emacs  (require 'buffer-fep) ƂsĉB

;;; Code:

;;;
;;; per-buffer fep control
;;;

(defvar buffer-fep-active-p nil
  "Preserve whether ASK68K was was active when the buffer previously visited.
This variable is always buffer local.")
(make-variable-buffer-local 'buffer-fep-active-p)

(defvar buffer-fep-previous-buffer (current-buffer))

(defun buffer-fep-post-command-hook-function ()
  (if (eq this-command 'universal-argument)
      (human-set-fep-active-p buffer-fep-active-p-ua)
    (if (and (not (eq (current-buffer) buffer-fep-previous-buffer))
	     human-do-fep-control)
	(let* ((obuf (current-buffer)))
	  (set-buffer buffer-fep-previous-buffer)
	  (setq buffer-fep-active-p (human-fep-active-p))
	  (set-buffer obuf)
	  (human-set-fep-active-p buffer-fep-active-p)
	  (setq buffer-fep-previous-buffer obuf)))))

(add-hook 'post-command-hook 'buffer-fep-post-command-hook-function)



;;;
;;; some special key 
;;;

(defun buffer-fep-isearch-mode-hook-function ()
  (setq buffer-fep-active-p (human-fep-active-p))
  (if buffer-fep-active-p
      (human-set-fep-active-p nil)))

(add-hook 'isearch-mode-hook 'buffer-fep-isearch-mode-hook-function)


(defun buffer-fep-isearch-mode-end-hook-function ()
  (if buffer-fep-active-p
      (human-set-fep-active-p t)))

(add-hook 'isearch-mode-end-hook 'buffer-fep-isearch-mode-end-hook-function)


(if (not (fboundp 'buffer-fep-universal-argument))
    (fset 'buffer-fep-universal-argument (symbol-function 'universal-argument)))

(defvar buffer-fep-active-p-ua nil)
(defun universal-argument ()
  (interactive)
  (setq buffer-fep-active-p-ua (human-fep-active-p))
  (human-set-fep-active-p nil)
  (buffer-fep-universal-argument))



;;; provide

(provide 'buffer-fep)
